package ExecuteScript;

require Exporter;
@ISA = qw(Exporter);

@EXPORT_OK = qw(execute_script);

use Reporting qw(start_report failed_report ok_report);

use strict;

# Executes a script from the NJS "interactively"
#
# Called in response to a #TSI_EXECUTESCRIPT string found in the 
# NJS message.


# arg 1 = Script to execute
#
# Returns void to TSI
#
#  success/failure to NJS
#
sub execute_script {
 
     my $script = shift;

	 # Substitute for these values as the executed script's
	 # environment will not (and if it did the values will
	 # be wrong). This is safe as thes script seen here is
	 # completely generated by the NJS and so we will not be 
	 # messing with any user created code.

     $script =~ s/\$USER/$ENV{USER}/g;
     $script =~ s/\$HOME/$ENV{HOME}/g;

     start_report("Executing a script.");
 
     my $output = `($script) 2>&1`;
 
     if($? != 0) {
		failed_report("$? $! $output"); # Added Feb 2002, more info to NJS
     }
     else {
        ok_report($output);
        print main::CMD_SOCK $output;
     }
 }
#
# $Id: ExecuteScript.pm,v 1.18 2002/04/09 17:42:08 svdb Exp $
#
# 04-05-01 Sven van den Berghe fecit Created from 3.0 TSI for Unicore 3.5
# 04-06-01 Sven van den Berghe fecit Replace $USER and $HOME
#
#                  Copyright (c) Fujitsu Ltd 2000 - 2002
#
#     Use and distribution is subject to the Community Source Licence.
#                                                       
# Further information is available from www.unicore.org or arcon@fecit.co.uk.
#
